Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 598876 - app-editors/gvim-8.0.0005 broken by gtk+3.22.2
Summary: app-editors/gvim-8.0.0005 broken by gtk+3.22.2
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal with 1 vote (vote)
Assignee: Vim Maintainers
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: gnome-3.22
  Show dependency tree
 
Reported: 2016-11-03 18:28 UTC by Harris Landgarten
Modified: 2017-11-30 16:35 UTC (History)
6 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Comment 1 Harris Landgarten 2016-11-03 19:29:38 UTC
I can confirm the arch patches fix gvim
Comment 2 Pacho Ramos gentoo-dev 2016-11-14 16:06:15 UTC
Reading https://bugzilla.gnome.org/show_bug.cgi?id=773387#c6 the next gtk+-3.22 version should solve this
Comment 3 Martin Wegner 2016-11-17 16:24:33 UTC
Meaning no offense, however, what would oppose shipping the same patches as ArchLinux for now to resolve this issue for the moment?

I applied both linked patches via epatch_user and gvim works for me again now.
Comment 4 Tiziano Müller (RETIRED) gentoo-dev 2016-11-22 18:58:24 UTC
according to https://github.com/vim/vim/commit/182707ac10d77359bf7a87c6b23ce4025d5b0ad4 the fix is in 3.22.4 and/or vim 8.0.0095
Comment 5 Gilles Dartiguelongue gentoo-dev 2016-11-23 07:56:41 UTC
Pushed gtk+-3.22.4, please check if it fixes this issue for you.
Comment 6 A Blamey 2016-11-23 10:25:01 UTC
gtk+-3.22.4 did not fully fix gvim for me.  The window opens at minimal size and the menus do not open at all when I run gvim on my gentoo box through an ssh tunnel to be displayed on Cygwin/X (v 1.18.4).  When displayed on local XFCE desktop it appears to work.

I'm seeing the following 4 errors repeated several times when starting gvim:

(gvim:17512): Gtk-CRITICAL **: gtk_widget_get_preferred_height_for_width: assertion 'width >= 0' failed

*** BUG ***
In pixman_region32_init_rect: Invalid rectangle passed
Set a breakpoint on '_pixman_log_error' to debug

(gvim:17512): Gtk-WARNING **: Negative content width -7 (allocation 1, extents 4x4) while allocating gadget (node arrow, owner GtkMenu)

(gvim:17512): Gtk-WARNING **: Negative content height -7 (allocation 1, extents 4x4) while allocating gadget (node menuitem, owner GtkMenuItem)


I believe the fixes above are incomplete.  I tried gtk+-3.22.4 with both gvim-8.0.0005 and gvim-9999.  Reverting to gtk+-3.20.9 got things working again.
Comment 7 Tiziano Müller (RETIRED) gentoo-dev 2016-11-23 12:08:13 UTC
For me, the update to gtk+-3.22.4 solved the issue.

For the record, the issue I had was:

I got error messages

(gvim:22696): Gtk-CRITICAL **: gtk_widget_set_size_request: assertion 'width >= -1' failed

(gvim:22696): Gtk-CRITICAL **: gtk_widget_set_size_request: assertion 'width >= -1' failed

(gvim:22696): Gtk-CRITICAL **: gtk_widget_set_size_request: assertion 'width >= -1' failed

(gvim:22696): Gtk-CRITICAL **: gtk_widget_set_size_request: assertion 'width >= -1' failed

.. and the editing area was only a couple of characters wide and about 3 lines high (using a tiling WM, maybe if I would have set it to floating the complete window would have been that small).
Comment 8 Mart Raudsepp gentoo-dev 2016-11-25 06:41:10 UTC
(In reply to A Blamey from comment #6)
> gtk+-3.22.4 did not fully fix gvim for me.  The window opens at minimal size
> and the menus do not open at all when I run gvim on my gentoo box through an
> ssh tunnel to be displayed on Cygwin/X (v 1.18.4).  When displayed on local
> XFCE desktop it appears to work.

Can you try the X11 forwarding tunnel case that isn't fixed with 3.22.1 or 3.22.0? Temporarily copying the 3.22.2 ebuild to 3.22.1 and/or 3.22.0 should probably work good enough.
Comment 9 A Blamey 2016-11-25 12:09:19 UTC
I was mistaken about this bug being the one causing my problem above.  This bug causes similar behavior, but the errors reported and underlying cause are different.

See https://github.com/vim/vim/issues/1187#issuecomment-262815607 for the open issue related to Cygwin/X.

gtk+-3.22.4 does fix the widget sizing bug for me on local X11.  On Cygwin/X when I use gtk+-3.22.3 the central text widget does not appear and I see the errors reported by Tiziano, in addition to the errors I listed in comment 6 - a combination of two bugs - which is where my confusion arose.

My problem appears to be some other change between gtk+-3.20 and gtk+-3.22 that only appears on Cygwin/X.  I suspect a difference between the xorg-x11 and Cygwin/X X11 implementations and/or X11 extensions that has been hit by some of many changes between the two gtk+ releases, especially to do with window sizing and menu positioning throughout the X11/mir/Wayland backend code.

For now I've switched gvim back to using gtk+:2 (via USE=gtk -gtk3) and it works flawlessly on local X11 and tunnelled Cygwin/X.  When future gtk+:3 releases appear I'll retest to see if the behaviour changes.
Comment 10 Pacho Ramos gentoo-dev 2017-02-01 21:20:38 UTC
what is pending to do here with the latest 3.22.x gtk+ version?